/*
flip51   Software for the ELV Flash Programmer FP51
Copyright (C) 1999-2003 Oliver Tscherwitschke <oliver@tscherwitschke.de>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _IO_H_
#define _IO_H_


#define VCC_ON		write_byte_to_latch(latch13 | 32, 2)
#define VCC_OFF		write_byte_to_latch(latch13 & ~32, 2)
#define VPP_5V_ON	write_byte_to_latch(latch13 | 64, 2)
#define VPP_5V_OFF	write_byte_to_latch(latch13 & ~64, 2)
#define VPP_12V_ON	write_byte_to_latch(latch13 | 128, 2)
#define VPP_12V_OFF	write_byte_to_latch(latch13 & ~128, 2)
#define RST_HIGH	write_byte_to_latch(latch14 | 64, 3)
#define RST_LOW		write_byte_to_latch(latch14 & ~64, 3)
#define PSEN_HIGH	write_byte_to_latch(latch14 | 32, 3)
#define PSEN_LOW	write_byte_to_latch(latch14 & ~32, 3)
#define PROG_HIGH	latch_7(latch7 | 16)
#define PROG_LOW	latch_7(latch7 & ~16)
#define OUTPUT_ENABLE	latch_7(latch7 | 8)
#define OUTPUT_DISABLE	latch_7(latch7 & ~8)


extern byte    latch7;     /* value stored in latches */
extern byte    latch13;
extern byte    latch14;


void latch_7(int value);
void write_byte_to_latch(int value, byte adr);
void set_mode(byte mode);
void wait_for_ready();


#endif
