/*
flip51   Software for the ELV Flash Programmer FP51
Copyright (C) 1999-2003 Oliver Tscherwitschke <oliver@tscherwitschke.de>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "types.h"
#include "tools.h"

/****************************************************************/
/* convert a hex digit to a value                               */
/****************************************************************/
byte hex_to_nibble(byte hex)
{
	if ((hex >= '0') && (hex <= '9'))
		return hex - 0x30;
	else		/* assume A - F */
		return hex - 'A' + 10;
}


/****************************************************************/
/* convert a string to an unsigned char value                   */
/****************************************************************/
byte _atoc(byte* buf)
{
	unsigned char val = 0;
	unsigned char i;
	
	for (i = 0; i < 2; i++)
	{
		val = val << 4;
		val |= hex_to_nibble(buf[i]);
	}
	
	return val;
}

/****************************************************************/
/* convert a string to an unsigned short value                  */
/****************************************************************/
unsigned short _atos(byte* buf)
{
	unsigned short val = 0;
	unsigned char i;
	
	for (i = 0; i < 4; i++)
	{
		val = val << 4;
		val |= hex_to_nibble(buf[i]);
	}
	
	return val;
}

/****************************************************************/
/* reverse the bit-order of one byte                            */
/* 01234567 ==> 76543210                                        */
/****************************************************************/
byte revb(byte b)
{
    byte result = 0;
    int i;

    for (i = 0; i < 8; i++) 
        if (b & (1 << i))
            result |= (1 << (7 - i)); 
    return result;
}

